/**
 * Grabar audio obtenido del micrófono con JavaScript
 * 
 */






const init = () => {

    medio=document.getElementById('medio');
    play=document.getElementById('play');
    //stoping=document.getElementById('stoping');
    //document.getElementById('stoping').style.display = 'none';
    document.getElementById('btnDetenerGrabacion').style.display = 'none';


  
   const accionPlay = () =>{

       if(!medio.paused && !medio.ended){
            medio.pause();
            play.value='\u25BA'; //\u25BA
            document.body.style.backgroundColor = '#fff';
            medio.muted = false;
            medio.volume = 1.0;
        }else{
            medio.play();
            play.value='||';
            document.body.style.backgroundColor = 'grey';
            medio.muted = false;
            //document.getElementById('play').style.display = 'none';
            //document.getElementById('pause').style.display = 'block';
        
        }
        }

    const accionStop = ()=>{
       
        medio.load();  
        document.getElementById('play').style.display = '';
        document.getElementById('stop').style.display = 'none';
            

    }

    const accionReiniciar = () =>{
 
        medio.load();        
     
    }
    const accionRetrasar = () =>{
        medio.currentTime -=1.0;
    }
    const accionAdelantar = () =>{
        medio.currentTime +=1.0;
    }

/*
    const accionMasVolumen = () =>{
        medio.volume += 0.1;
    }

    const accionMenosVolumen = () =>{
        medio.volume -= 0.1;
    }
*/
    // Final nueva estructura 

        const tieneSoporteUserMedia = () =>
            !!(navigator.mediaDevices.getUserMedia)

        // Si no soporta...
        // Amable aviso para que el mundo comience a usar navegadores decentes ;)
        if (typeof MediaRecorder === "undefined" || !tieneSoporteUserMedia())
            return alert("Tu navegador web no cumple los requisitos; por favor, actualiza a un navegador decente como Firefox o Google Chrome");


        // Declaración de elementos del DOM
        //const $listaDeDispositivos = document.querySelector("#listaDeDispositivos"),
          const  $duracion = document.querySelector("#duracion"),
            $btnComenzarGrabacion = document.querySelector("#btnComenzarGrabacion"),
            $btnDetenerGrabacion = document.querySelector("#btnDetenerGrabacion");

        // Algunas funciones útiles
        /*const limpiarSelect = () => {
            for (let x = $listaDeDispositivos.options.length - 1; x >= 0; x--) {
                $listaDeDispositivos.options.remove(x);
            }
        }*/

        const segundosATiempo = numeroDeSegundos => {
            let horas = Math.floor(numeroDeSegundos / 60 / 60);
            numeroDeSegundos -= horas * 60 * 60;
            let minutos = Math.floor(numeroDeSegundos / 60);
            numeroDeSegundos -= minutos * 60;
            numeroDeSegundos = parseInt(numeroDeSegundos);
            if (horas < 10) horas = "0" + horas;
            if (minutos < 10) minutos = "0" + minutos;
            if (numeroDeSegundos < 10) numeroDeSegundos = "0" + numeroDeSegundos;

            return `${horas}:${minutos}:${numeroDeSegundos}`;
        };
        // Variables "globales"
        let tiempoInicio, mediaRecorder, idIntervalo;
        const refrescar = () => {
                $duracion.textContent = segundosATiempo((Date.now() - tiempoInicio) / 1000);
            }
            // Consulta la lista de dispositivos de entrada de audio y llena el select
        /*const llenarLista = () => {
            navigator
                .mediaDevices
                .enumerateDevices()
                .then(dispositivos => {
                   limpiarSelect();
                    dispositivos.forEach((dispositivo, indice) => {
                        if (dispositivo.kind === "audioinput") {
                            const $opcion = document.createElement("option");
                            // Firefox no trae nada con label, que viva la privacidad
                            // y que muera la compatibilidad
                            $opcion.text = dispositivo.label || `Dispositivo ${indice + 1}`;
                            $opcion.value = dispositivo.deviceId;
                            $listaDeDispositivos.appendChild($opcion);
                        }
                    })
                })
        };*/
        // Ayudante para la duración; no ayuda en nada pero muestra algo informativo
        const comenzarAContar = () => {
            tiempoInicio = Date.now();
            idIntervalo = setInterval(refrescar, 500);
        };

        // Comienza a grabar el audio con el dispositivo seleccionado
        const comenzarAGrabar = () => {

            document.getElementById('btnDetenerGrabacion').style.display = '';
            document.getElementById('btnComenzarGrabacion').style.display = 'none';

        medio.load();
        medio.play();
        medio.muted = true;
           // if (!$listaDeDispositivos.options.length) return alert("No hay dispositivos");
            // No permitir que se grabe doblemente
            if (mediaRecorder) return alert("Ya se está grabando");

            navigator.mediaDevices.getUserMedia({
                    audio: {
                        //deviceId: $listaDeDispositivos.value,
                    }
                })
                .then(
                    stream => {
                        // Comenzar a grabar con el stream
                        mediaRecorder = new MediaRecorder(stream);
                        mediaRecorder.start();
                        comenzarAContar();
                        // En el arreglo pondremos los datos que traiga el evento dataavailable
                        const fragmentosDeAudio = [];
                        // Escuchar cuando haya datos disponibles
                        mediaRecorder.addEventListener("dataavailable", evento => {
                            // Y agregarlos a los fragmentos
                            fragmentosDeAudio.push(evento.data);
                        });
                        // Cuando se detenga (haciendo click en el botón) se ejecuta esto
                        mediaRecorder.addEventListener("stop", () => {
                            // Detener el stream
                            stream.getTracks().forEach(track => track.stop());
                            // Detener la cuenta regresiva
                            detenerConteo();
                            // Convertir los fragmentos a un objeto binario
                            const blobAudio = new Blob(fragmentosDeAudio);

                            // Crear una URL o enlace para descargar
                            const urlParaDescargar = URL.createObjectURL(blobAudio);
                            // Crear un elemento <a> invisible para descargar el audio
                            let a = document.createElement("a");
                            document.body.appendChild(a);
                            a.style = "display: none";
                            a.href = urlParaDescargar;
                            a.download = "grabacion_english.webm";
                            // Hacer click en el enlace
                            a.click();
                            // Y remover el objeto
                            window.URL.revokeObjectURL(urlParaDescargar);
                        });
                    }
                )
                .catch(error => {
                    // Aquí maneja el error, tal vez no dieron permiso
                    console.log(error)
                });
        };


        const detenerConteo = () => {
            document.getElementById('btnComenzarGrabacion').style.display = '';
            document.getElementById('btnDetenerGrabacion').style.display = 'none';
            clearInterval(idIntervalo);
            tiempoInicio = null;
            $duracion.textContent = "";
            
        }

        const detenerGrabacion = () => {
            if (!mediaRecorder){

              
            document.getElementById('btnDetenerGrabacion').style.display = 'none';
            document.getElementById('btnComenzarGrabacion').style.display = '';
            return alert("No se está grabando");}

           
            medio.load();
            mediaRecorder.stop();
            mediaRecorder = null;
        };

        /*const Mostrar = () => {
          
            document.getElementById('text').style.display = 'block';
        };
        const Oculatar = () => {
          
            document.getElementById('text').style.display = 'none';
        };*/


        $btnComenzarGrabacion.addEventListener("click", comenzarAGrabar);
        $btnDetenerGrabacion.addEventListener("click", detenerGrabacion);
        play.addEventListener('click', accionPlay);
        //pause.addEventListener('click', accionStop);
        /*ayuda.addEventListener("click", Mostrar);
        cerrar.addEventListener("click", Oculatar);*/



        medio=document.getElementById('medio');
        play=document.getElementById('play');
        reiniciar=document.getElementById('reiniciar');
        retrasar=document.getElementById('retrasar');
        adelantar=document.getElementById('adelantar');
        //silenciar=document.getElementById('silenciar');

        play.addEventListener('click', accionPlay);
        reiniciar.addEventListener('click', accionReiniciar);
        retrasar.addEventListener('click', accionRetrasar);
        adelantar.addEventListener('click', accionAdelantar);

        // Cuando ya hemos configurado lo necesario allá arriba llenamos la lista

       // llenarLista();
    }
    // Esperar a que el documento esté listo...
document.addEventListener("DOMContentLoaded", init);

